//import D3.js modules
import {
  scaleLinear,
  scaleOrdinal,
  extent,
  axisLeft,
  axisBottom,
  symbols,
  symbol,
} from 'd3';
// Define function the scatterPlot
export const scatterPlot = () => {
  let xValue;//variables for scatter plot
  let yValue;let width;
  let height;
  let data;
  let symbolValue;
  let margin;
  let size;
//scale for x axes
  const my = (selection) => {
    const x = scaleLinear()
      .domain(extent(data, xValue))
      .range([margin.left, width - margin.right]);
//scale for y axes
    const y = scaleLinear()
      .domain(extent(data, yValue))
      .range([height - margin.bottom, margin.top]);
//scale for symbol values
    const symbolScale = scaleOrdinal()
      .domain(data.map(symbolValue))
      .range(symbols);
// Generate marks for the scatter plot based on input data
    const symbolGenerator = symbol().size(size);
    
    const marks = data.map((d) => ({
      x: x(xValue(d)),
      y: y(yValue(d)),
      pathD: symbolGenerator.type(symbolScale(symbolValue(d)))()
    }));

    selection
      .selectAll('path')
      .data(marks)
      .join('path')
      .attr('d', (d) => d.pathD)
      .attr('transform', (d) => `translate(${d.x},${d.y})`);

//render the y-axis
    selection
      .append('g')
      .attr('transform', `translate(0,${height - margin.bottom})`)
      .call(axisBottom(x))
      .append('text')
      .attr('x', width - margin.right)
      .attr('y', -4)
      .attr('fill', 'currentColor')
      .attr('font-size', '1.2em')
      .attr('text-anchor', 'end')
      .text('petal_width');
 //render the x-axis   
    selection
      .append('g')
      .attr('transform', `translate(${margin.left},0)`)
      .call(axisLeft(y))
      .append('text')
      .attr('x', 4)
      .attr('y', margin.top - 4)
      .attr('fill', 'currentColor')
      .attr('font-size', '.9em')
      .text('sepal_length');
  };

  my.width = function (_) {
    return arguments.length ? ((width = +_), my) : width;
  };

  my.height = function (_) {
    return arguments.length ? ((height = +_), my) : height;
  };

  my.data = function (_) {
    return arguments.length ? ((data = _), my) : data;
  };

  my.xValue = function (_) {
    return arguments.length ? ((xValue = _), my) : xValue;
  };

  my.yValue = function (_) {
    return arguments.length ? ((yValue = _), my) : yValue;
  };

  my.symbolValue = function (_) {
    return arguments.length
      ? ((symbolValue = _), my)
      : symbolValue;
  };

  my.margin = function (_) {
    return arguments.length ? ((margin = _), my) : margin;
  };

  my.size = function (_) {
    return arguments.length ? ((size = +_), my) : size;
  };

  return my;
};
